
PROGRAM INTVEC;

{ SAVE / RESTORE INTERRUPTVEKTOREN }


USES  SELECTD;


TYPE  INTBUF = ARRAY[0..$CF] OF LONGINT;


VAR   I,J   : WORD;
      S     : STRING;
      INTS  : INTBUF ABSOLUTE 0:0;
      F     : FILE OF INTBUF;


PROCEDURE ERKLAERE;
BEGIN
  WRITELN;
  WRITELN('Programm INTVEC');
  WRITELN;
  WRITELN('INTVEC S    speichert die Interrupt- Vektoren auf File');
  WRITELN('INTVEC R    restauriert die Interrupt- Vektoren von File');
  WRITELN('INTVEC D    lscht File INTVEC.SAV');
  WRITELN;
  WRITELN('Es wird das File INTVEC.SAV auf demselben Directory wie INTVEC.EXE benutzt.');
  WRITELN;
  HALT;
END;


BEGIN
  IF PARAMCOUNT = 0 THEN ERKLAERE;
  S := PARAMSTR(1);
  FOR I := 1 TO LENGTH(S) DO S[I] := UPCASE(S[I]);
  IF LENGTH(S) > 1 THEN IF (S[1] = '/') OR (S[1] = '-') THEN DELETE(S,1,1);

{$I-}
  ASSIGN(F,'INTVEC.SAV');
  IF  S[1] = 'S' THEN BEGIN
    REWRITE(F);
    IF IORESULT = 0 THEN BEGIN
      WRITE(F,INTS);
      CLOSE(F);
    END;
  END;
  IF S[1] = 'R' THEN BEGIN
    RESET(F);
    IF IORESULT = 0 THEN BEGIN
      READ(F,INTS);
      CLOSE(F);
    END;
    IF S[2] = 'D' THEN ERASE(F);
  END;
  IF S[1] = 'D' THEN ERASE(F);

END.


